import 'dart:async';
import 'dart:io';

import 'package:sqlite3_driver/sqlite3_driver.dart';
import 'package:test/test.dart';

Future main() async {
  test("SQLite database engine driver", () async {
    var filename = ":memory:";
    var file = new File(filename);
    if (file.existsSync()) {
      file.deleteSync();
    }

    var conn = new Sqlite3Connection(filename);
    try {
      await conn.open();
      var stmtCreateTable = new Sqlite3Statement(conn, sqlCreateTable);
      await stmtCreateTable.execute();
      var stmtInsertData = new Sqlite3Statement(conn, sqlInsertData);
      for (var data in intilaData) {
        await stmtInsertData.execute(data);
      }

      var stmtSelectData = new Sqlite3Statement(conn, sqlSelectData);
      var rows = await stmtSelectData.executeQuery();
      var index = 0;
      await for (var row in rows) {
        var original = intilaData[index];
        for (var i = 0; i < row.length; i++) {
          expect(row[i], original[i]);
        }

        var i = 0;
        for (var name in row.names) {
          expect(row[name], original[i++]);
        }

        index++;
      }

      var stmtUpdateData = new Sqlite3Statement(conn, sqlUpdateData);
      await stmtUpdateData.executeQuery({":AGE": 25, ":NEW_AGE": 26});
      var changes = await conn.affectedRows;
      expect(changes, 2);

      var stmtSelectCount = new Sqlite3Statement(conn, sqlSelectCount);
      rows = await stmtSelectCount.executeQuery([26]);
      var count = 0;
      await for (var row in rows) {
        count += row[0];
      }

      expect(count, 2);
    } finally {
      await conn.close();
    }
  });
}

List<List> intilaData = [
  [1, 'Gérard', 32, 'California', 20000.00, []],
  [2, 'Allen', 25, 'Texas', 15000.00, null],
  [3, 'Teddy', 23, 'Norway', 20000.00, [1, 2, 3]],
  [4, 'Mark', 25, 'Rich-Mond ', 65000.00, [123]],
];

String sqlCreateTable = """
CREATE TABLE COMPANY (
ID INT PRIMARY KEY NOT NULL,
NAME TEXT NOT NULL,
AGE INT NOT NULL,
ADDRESS CHAR(50),
SALARY REAL,
DATA BLOB);
""";

String sqlInsertData = """
INSERT INTO COMPANY (ID, NAME, AGE, ADDRESS, SALARY, DATA)
VALUES (:ID, :NAME, :AGE, :ADDRESS, :SALARY, :DATA);
""";

String sqlSelectCount = """
SELECT COUNT(*)
FROM COMPANY
WHERE AGE = ?""";

String sqlSelectData = """
SELECT * FROM COMPANY""";

String sqlUpdateData = """
UPDATE COMPANY
SET AGE = :NEW_AGE
WHERE AGE = :AGE""";
